<ui:composition
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:rich="http://richfaces.org/rich"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:g="http://www.ihe.net/gazelle"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns="http://www.w3.org/1999/xhtml">
    <h1>#{messages['gazelle.simu.MessagesBrowser']}</h1>
    <h:form id="globalform">
        <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
        <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                       value="#{managedBean.filter.urlParameters}"/>
        <script>
            updateUrl("globalform:filterUrlParameters");
            jq162("#globalform\\:filterUrlParameters").bind('change',
                function () {
                    updateUrl("globalform:filterUrlParameters");
                });
        </script>
        <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
            <ui:define name="panel_title">#{messages['gazelle.simu.SearchCriteria']}</ui:define>
            <div class="row">
                <div class="col-md-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="domain"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simu.Domain']}"/>
                        <ui:param name="filterForm" value="globalform"/>
                    </ui:include>
                </div>
                <div class="col-md-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="simulatedActor"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simu.SimulatedActor']}"/>
                        <ui:param name="filterForm" value="globalform"/>
                    </ui:include>
                </div>

                <div class="col-md-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="transaction"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simu.Transaction']}"/>
                        <ui:param name="filterForm" value="globalform"/>
                    </ui:include>
                </div>
            </div>
            <div class="row">
                <div class="col-md-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="initiator"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simu.InitiatorRole']}"/>
                        <ui:param name="filterForm" value="globalform"/>
                    </ui:include>
                </div>
                <div class="col-md-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="responder"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simu.ResponderRole']}"/>
                        <ui:param name="filterForm" value="globalform"/>
                    </ui:include>
                </div>
                <div class="col-md-4"></div>
            </div>
            <div class="row">
                <div class="col-md-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="requestIssuer"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simu.Initiator']}"/>
                        <ui:param name="filterForm" value="globalform"/>
                    </ui:include>
                </div>
                <div class="col-md-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="responseIssuer"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simu.Responder']}"/>
                        <ui:param name="filterForm" value="globalform"/>
                    </ui:include>
                </div>
                <div class="col-md-4">
                    <s:decorate template="/layout/form/_checkbox.xhtml"
                                rendered="#{identity.loggedIn}">
                        <h:selectBooleanCheckbox value="#{managedBean.onlyMyMessages}">
                            <a4j:ajax event="change" render="globalform"/>
                        </h:selectBooleanCheckbox>
                        #{messages['gazelle.simu.DisplayOnlyMyMessages']}
                    </s:decorate>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <ui:include src="/filter/filterDate.xhtml">
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="timestamp"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simu.Timestamp']}"/>
                        <ui:param name="filterForm" value="globalform"/>
                    </ui:include>
                </div>
            </div>
            <ui:define name="filter_buttons">
                <a4j:commandLink title="#{messages['net.ihe.gazelle.simulators.RefreshResults']}"
                                 render="globalform">
                    <span class="gzl-icon-refresh"/>
                </a4j:commandLink>
                <a4j:commandLink title="#{messages['net.ihe.gazelle.simulators.Reset']}"
                                 actionListener="#{managedBean.reset()}"
                                 render="globalform">
                    <span class="fa fa-times-circle"></span>
                </a4j:commandLink>
            </ui:define>
        </ui:decorate>
        <s:div styleClass="gzl-alert gzl-alert-orange"
               rendered="#{managedBean.restrictAccessToMessages}">
            <h:outputText value="#{messages['net.ihe.gazelle.simulators.TheAdministratorHasRestrictedTheAccessToTheMessa']} "/>
            <h:outputText value="#{messages['net.ihe.gazelle.simulators.YouAreOnlySeeingTheMessagesSentByAnonymousUsers']}"
                          rendered="#{not identity.loggedIn}"/>
            <s:span rendered="#{identity.loggedIn and not(s:hasRole('admin_role') or s:hasRole('monitor_role'))}">
                <h:outputText
                        value="#{messages['net.ihe.gazelle.simulators.YouAreOnlySeeingTheMessagesSentByTheUsersFromYou']})"/>
                <ul>
                    <a4j:repeat value="#{managedBean.getIpListForLoggedInUser()}" var="ip">
                        <li>
                            <h:outputText value="#{ip}"/>
                        </li>
                    </a4j:repeat>
                </ul>
            </s:span>
        </s:div>
        <ui:decorate template="/layout/panels/_panel_title.xhtml">
            <ui:define name="panel_title">#{messages['gazelle.simu.Messages']}</ui:define>
            #{dataTableStateHolder.setDescendingOn('timestamp')}
            <rich:dataTable value="#{managedBean.getTransactionInstanceList()}"
                            var="ti" rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="messageList" render="ds">
                <ui:include src="/messages/logger_columns.xhtml"/>
                <g:column sortBy="#{'companyKeyword'}" rendered="#{s:hasRole('admin_role') or s:hasRole('monitor_role')}"
                          sortOrder="#{dataTableStateHolder.sortOrders['companyKeyword']}"
                          filterBy="#{'companyKeyword'}" filterEvent="keyup">
                    <ui:define name="header">#{messages['gazelle.simu.Owner']}</ui:define>
                    <h:outputText value="#{ti.companyKeyword}" rendered="#{not empty ti.companyKeyword}"/>
                    <h:outputText value="#{ti.request.issuerIpAddress}" rendered="#{not empty ti.request.issuerIpAddress}"/>
                </g:column>
                <g:column>
                    <f:facet name="header">#{messages['users.Action']}</f:facet>
                    <div class="gzl-never-wrap">
                        <h:outputLink value="#{managedBean.permanentLink(ti)}"
                                      title="#{messages['users.Details']}">
                            <s:span styleClass="gzl-icon-search "/>
                        </h:outputLink>
                        <a4j:commandLink actionListener="#{managedBean.validate(ti)}"
                                         oncomplete="jq162('#validationSummaryPanel').modal('show')"
                                         render="validationSummaryPanelContent"
                                         title="#{messages['net.ihe.gazelle.simulators.ClickToValidate']}">
                            <s:span styleClass="fa fa-play gzl-text-blue"/>
                        </a4j:commandLink>
                        <a4j:commandLink
                                actionListener="#{managedBean.hideMessage(ti, false)}"
                                rendered="#{not ti.visible and (applicationConfigurationManager.worksWithoutCas or s:hasRole('admin_role'))}"
                                render="messageList"
                                title="#{messages['net.ihe.gazelle.simulators.HideMessageFromList']}">
                            <s:span styleClass="gzl-icon-eye "/>
                        </a4j:commandLink>
                        <a4j:commandLink
                                actionListener="#{managedBean.hideMessage(ti, true)}"
                                rendered="#{ti.visible and (applicationConfigurationManager.worksWithoutCas or s:hasRole('admin_role'))}"
                                render="messageList"
                                title="#{messages['net.ihe.gazelle.simulators.MakeMessageAvailable']}">
                            <s:span styleClass="gzl-icon-eye-slash "/>
                        </a4j:commandLink>
                        <a4j:commandLink
                                actionListener="#{managedBean.setMessageForReplay(ti)}"
                                rendered="#{ti.isSentFromSimulator()}"
                                oncomplete="jq162('#replayPanel').modal('show')"
                                render="replayPanelDiv"
                                title="#{messages['net.ihe.gazelle.simulators.ReplayMessage']}">
                            <s:span styleClass="fa fa-repeat gzl-text-blue gzl-icon-action"/>
                        </a4j:commandLink>
                    </div>
                </g:column>
                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="ds"/>
                        <ui:param name="dataTableId" value="messageList"/>
                    </ui:include>
                </f:facet>
            </rich:dataTable>
        </ui:decorate>
        <ui:include src="/messages/validationSummaryPanel.xhtml"/>
        <ui:include src="/messages/replayPanel.xhtml"/>
    </h:form>
</ui:composition>
